# TP Loto

Énoncé du TP : [https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/](https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/)

## Question Loto 1 : Quels sont les signaux à renseigner dans la liste de sensibilité (si vous utilisez un process explicite) ?

On renseigne les signaux I_0, I_1, I_3, I_4, I_5 et I_sel. A chaque fois qu'une modification est notée sur l'un de ces signaux, le process se lance. Il est sensible à une modification de chaun de ces signaux.


## Question Loto 2 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ?

Lorsqu'on retire un when des combinaisons d'entrées du module, la commande when others attribue automatiquement à cette combinaison non renseignée le signal de sortie. On a donc pas de problèmes de simulation mais deux combinaisons qui donnent la même sortie.
En revanche, lorsque le when others est supprimé, il y'a des combinaisons non traitées, la simulation ne se lance alors pas.


## Question Loto 3 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.

Ce test n'est pas complètement concluant. Le multiplexer est fonctionnel mais le programme test bench ne couvre pas les cas où I_sel est égal à 6 ou 7. Le when others du process permet de son côté de couvrir ces cas.
Il faudrait modifier la condition dans le test bench pour que la variable commande puisse prendre les valeurs 110 et 111.

![Simu pas complète](./question3-1.png)
![Simu pas complète](./question3-2.png)


## Question Loto 4 : Quel(s) signal(aux) doit on renseigner dans la liste de sensibilité de ce processus séquentiel ? Pourquoi ?

On renseigne I_clk, I_rst et I_block. Le processus doit être sensible à chacun de ses signaux.


## Question Loto 5 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ici ?

Si le test est imcomplet et c'est la cas ici car on ne teste pas toutes les combinaisosn à chaque état du compteur, on ne peut pas conclure sur un fonctionnement parfait du compteur et ce n'est pas grave car la valeur I_block est indépendante de l'état du compteur. .


## Question Loto 6 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.

Le test bench teste toutes les combinaisons possible entre les signaux d'entrée comme par exemple un I_block =1 juste après un I_rst =1. La réinitialisation et le blocage sont fonctionnels ainsi que le comptage de 0 à 5.
![Simu pas complète](./question6.png)


## Question Loto 7 : Combien de processus avez-vous décris ?

Nous avons décris un process.


## Question Loto 8 : De quel(s) type(s) sont-ils

c'est un process synchrone.


## Question Loto 9 : Serait-il possible de décrire cette machine d'état de manière différente, en terme de nombre et de type de process ?

Oui, on aurait pu utiliser deux process, l'un synchrone pour passer de l'état présent à l'état futur à chaque front montant d'horloge. Le second est asynchrone et suit l'architecture de la FSM.

## Question Loto 10 : Ce test est-il concluant ? Justifiez.

Oui, le test est concluant. On teste bien tous les états et on a vérifié les attributions de chaque signal lors des fronts montants d'horloge.

## Question Loto 11 : Le circuit inféré par l’outil est-il conforme à l’attendu ? Sinon, en quoi diffère-t-il et est-ce lié à une erreur de description VHDL ?

Il n'y a pas le bufr présent sur le design du sujet. Non , il n'ya pas d'erreur.

## Question Loto 12 : Quelles sont les ressources utilisées sur le FPGA ? En quelle quantité/proportion des ressources disponibles ? Des **LATCHES** sont-ils utilisés ? Est-ce positif ou pas, pourquoi ?

![tableau des ressources](./question12.png)

On n'utilise pas de latches. C'est positif car on n'a ainsi pas de mémoire asynchrone.


## Question Loto 13 : Le tirage est-il aléatoire pour un humain ? pour une machine ? Justifiez.

Il est aléatoire pour l'humain qui ne voit ce qu'il se passe dans le compteur tirage mais ne l'est pour la machine qui suit le cycle du compteur. 

